

-- UI Class --
--------------
local Ui = {}
local fuelbar
local destIndicator


function Ui:init()
  -- Fuel --
  ----------
  fuelbar = {}
  fuelbar.image = love.graphics.newImage("assets/hudFuel.png")
  fuelbar.w = fuelbar.image:getWidth()
  fuelbar.h = fuelbar.image:getHeight()
  fuelbar.x = 128 - fuelbar.w / 2
  fuelbar.y = HEIGHT - 12
  fuelbar.value = player.fuel
  fuelbar.length = 0
  
  function fuelbar:draw()
    self.value = player.fuel
    self.length = self.value / 100 * self.w
    if player.fuel < 20 then love.graphics.setColor(200, 50, 50) end
    love.graphics.rectangle("fill", self.x, self.y + 2.5, self.length,self.h - 2)
    love.graphics.setColor(255, 255, 255)
    love.graphics.draw(self.image, self.x, self.y+1.5)
    printFontCentered(FONT.small, "Fuel", self.x, self.y - 4, self.w)
  end
  
  -- Destination Indicator --
  ---------------------------
  destIndicator = {}
  destIndicator.x = WIDTH / 2 - 8
  destIndicator.y = HEIGHT - 12

  function destIndicator:draw()
      printFontCentered(FONT.small, "Station", self.x + 38, self.y - 4, FONT.small:getWidth("Station"))
      if player.destination then 
        love.graphics.setColor(50, 150, 200)
        printFontCentered(FONT.small, player.destination, self.x+38, self.y+4, FONT.small:getWidth("Station"))
        love.graphics.setColor(255, 255, 255)
      else
        love.graphics.setColor(50, 150, 200)
        printFontCentered(FONT.small, "x", self.x+38, self.y+4, FONT.small:getWidth("Station")) 
        love.graphics.setColor(255, 255, 255)
      end
  end
  
  -- Lifes --
  -----------
  lifeIndicator = {}
  lifeIndicator.image = love.graphics.newImage("assets/taxiIcon.png")
  lifeIndicator.w = lifeIndicator.image:getWidth()
  lifeIndicator.h = lifeIndicator.image:getHeight()
  lifeIndicator.x = WIDTH - 64
  lifeIndicator.y = HEIGHT - 12

  function lifeIndicator:draw()
    lifeIndicator.lives = player.lives
    printFontCentered(FONT.small, "Lives", self.x + 21, self.y - 4, FONT.small:getWidth("Lives"))
    for i = 1, lifeIndicator.lives do
      love.graphics.draw(self.image, self.x + (i*10), self.y + 4)
    end
  end
  
  -- Money --
  -----------
  moneyIndicator = {}
  moneyIndicator.x = 16
  moneyIndicator.y = HEIGHT - 12

  function moneyIndicator:draw()
    printFontCentered(FONT.small, "Money", self.x, self.y - 4, FONT.small:getWidth("Money"))
    printFontCentered(FONT.small, math.floor(player.money).."$", self.x - 12, self.y + 5 , FONT.small:getWidth(math.floor(player.money).."$"))
    if player.passengerMoney then
      love.graphics.setColor(50, 150, 200)
      printFontCentered(FONT.small, math.floor(player.passengerMoney).."$", self.x + 30, self.y + 5 , FONT.small:getWidth(math.floor(player.passengerMoney).."$"))
      love.graphics.setColor(255, 255, 255)
    else
      love.graphics.setColor(50, 150, 200)
      printFontCentered(FONT.small, "0$", self.x + 30, self.y + 5 , FONT.small:getWidth("0$"))
      love.graphics.setColor(255, 255, 255)
    end
  end

end


function Ui:update(dt)
end


function Ui:draw()
  fuelbar:draw()
  destIndicator:draw()
  lifeIndicator:draw()
  moneyIndicator:draw()
end

return Ui
